import os
import yaml

# Try to import CLoader from PyYAML for performance improvement; fallback to standard Loader if unavailable
try:
    from yaml import CLoader as Loader
except ImportError:
    from yaml import Loader

import numpy as np
from colorama import Fore, Style

from .HPRO_functions import economic_function

from ...common import calculate_annual_depreciation_cost
from ...common import calculate_pump_efficiency
from ...common import density_seawater_liquid
from ...common import ResultList

def estimate_pump_cost(flow_rate_m3h, pressure_delta, tech_params, proj_params):
    """
    Estimate the cost of the high-pressure pump based on flow rate and pressure.

    Parameters:
    flow_rate_m3h (float): The feed flow rate in m³/h.
    pressure_delta (float): The required pressure difference (in bar) to be generated by the pump.
    tech_params (dict): Dictionary containing technical configuration and parameters.
    proj_params (dict): Dictionary containing project-specific configuration and parameters.

    Returns:
    float: Estimated pump cost in USD_current.
    """
    if flow_rate_m3h <= 450:
        return economic_function.estimation_HPpump_cost_single(flow_rate_m3h, pressure_delta, tech_params, proj_params)
    else:
        return economic_function.estimation_HPpump_cost_parallpumps(flow_rate_m3h, pressure_delta, tech_params, proj_params)
    
def validate_feed_concentration(feed_ion_conc_ppm_tot, tech_config_and_params):
    """
    Validates that the total feed ion concentration for HPRO is within a 5% (or given) error margin
    of the required concentration.

    Parameters:
        feed_ion_conc_ppm_tot (float): Total ion concentration in ppm.
        tech_config_and_params (dict): A dictionary containing the reference feed concentration under the key 'ref_feed_conc_ppm',
                                      as well as %-factor of allowable variation under the key 'allowable_feed_ppm_variation'.

    Raises:
        ValueError: If the concentrations are not within a 5% (or given) error margin.
    """
    feed_ion_required_conc_ppm_tot = tech_config_and_params['ref_feed_conc_ppm']
    #print("feed_ion_conc_ppm_tot", feed_ion_conc_ppm_tot, type(feed_ion_conc_ppm_tot))
    #print("feed_ion_required_conc_ppm_tot", feed_ion_required_conc_ppm_tot, type(feed_ion_required_conc_ppm_tot))

    # Calculate the acceptable margin of error
    allowed_margin = tech_config_and_params['allowable_feed_ppm_variation'] * feed_ion_required_conc_ppm_tot

    # Check if the concentration difference is within the allowed margin
    if abs(feed_ion_conc_ppm_tot - feed_ion_required_conc_ppm_tot) > allowed_margin:
        raise ValueError(f"Error: The feed ion concentration {feed_ion_conc_ppm_tot} ppm is not within the "
                         f"allowed 5% margin of the required concentration {feed_ion_required_conc_ppm_tot} ppm.")
    else:
        print("Validation successful: Feed ion concentration is within the allowed 5% (or given) error margin.")


def hpro_model(tech_config_and_params, proj_config_and_params, N_trains, feed_vol_flow_per_train_m3h, Pfeed_hpp, feed_ion_conc_ppm_tot, electricity_cost, with_erd, following_tech):

    # feed ppm validation (since HPRO costs and energy consumption are based on a specific HPRO from literature)
    retent_ion_conc_ppm_tot = tech_config_and_params['ref_retentate_conc_ppm']
    validate_feed_concentration(feed_ion_conc_ppm_tot, tech_config_and_params)


    # read techno-economic params from dict
    Pfeed = tech_config_and_params['feed_pressure']  # [bar]
    recovery_rate = tech_config_and_params['recovery_rate']  # [%-factor]
    perm_ion_conc_ppm_tot = tech_config_and_params['ref_perm_conc_ppm']
    #membrane_area = tech_config_and_params['membrane_area_hpro']  # [m2]
    spec_elec_consumption = tech_config_and_params['spec_elec_consumption']  # [kWh_el/m3 of perm]
    spec_capital_cost = tech_config_and_params['spec_capital_cost'] * proj_config_and_params['CEPCI']['current'] / proj_config_and_params['CEPCI'][tech_config_and_params['ref_cost_year']] # [USD_current/(m3_capacity/day)]
    spec_fixed_opex = tech_config_and_params['spec_fixed_opex'] * proj_config_and_params['CEPCI']['current'] / proj_config_and_params['CEPCI'][tech_config_and_params['ref_cost_year']]  # [USD_current/year/(m3_capacity/day)]
    price_purewat_usd_m3 = proj_config_and_params['spec_price_commodity']['water']
    
    # output flow rates and pressure
    Qperm_m3h = feed_vol_flow_per_train_m3h * recovery_rate
    Qperm_m3_per_annum = Qperm_m3h * 8760 * tech_config_and_params['plant_availability']
    Qperm_m3day_capacity = Qperm_m3h * 24  # [capacity of m3_perm/day]
    Qretent_m3h = feed_vol_flow_per_train_m3h * (1 - recovery_rate)
    Qretent_m3_per_annum = Qretent_m3h * 8760 * tech_config_and_params['plant_availability']
    Pretent = Pfeed - tech_config_and_params['retentate_head_loss']  # [bar]
    # mass flow rates
    #Qfeed_m3h = Mfeed * 3600 / density_seawater_liquid(tech_config_and_params['Feed_temperature'], Xfeed)
    Mperm_kgh = Qperm_m3h * 1000  # assuming its density to be 1000 kg/m3
    Mretent_kgh = Qretent_m3h * density_seawater_liquid(25, retent_ion_conc_ppm_tot)  # [kg/m3]
    
    ###############
    ## Energy Recovery Device (ERD) Calculations

    # Allowable portion of feed_vol_flow_per_train_m3h into ERD for pressure increase: 
    # Calculated using ERD efficiency formula (ref: Sanz Miguel A.; Stover R. 2007) 
    # and expected outlet pressure for Vfeed_erd, based on assumed booster pump pressure delta.

    

    if with_erd:
        print("Considering ERD and its effects")
        
        # Input: High-pressure retentate from HPRO
        Pin_erd_hp = Pretent  # [bar]

        # Determine allowable pressure of ERD output (low pressure) for OARO or electrodialysis
        Pout_erd_lp_oaro, Pout_erd_lp_ed, Qin_erd_lp_m3h_oaro, Qin_erd_lp_m3h_ed = get_erd_flowrates(
            tech_config_and_params, Pfeed, Qretent_m3h, Pin_erd_hp
        )
        Qin_erd_hp_m3h = Qretent_m3h

        # High-pressure diverted feed pressurized by ERD = Low-pressure diverted feed before pressurization (assuming no losses / mixing in ERD)
        Qout_erd_hp_m3h_oaro = Qin_erd_lp_m3h_oaro  # Volume for HPRO (OARO)
        Qout_erd_hp_m3h_ed = Qin_erd_lp_m3h_ed      # Volume for HPRO (ED)

        # High Pressure Pump (HPP) and Booster Pump (BPP) Feed Flows
        Qfeed_hpp_m3h_oaro = feed_vol_flow_per_train_m3h - Qout_erd_hp_m3h_oaro  # Feed to HPP (OARO)
        Qfeed_bpp_m3h_oaro = Qout_erd_hp_m3h_oaro                  # Feed to BPP (OARO)
        Qfeed_hpp_m3h_ed = feed_vol_flow_per_train_m3h - Qout_erd_hp_m3h_ed      # Feed to HPP (ED)
        Qfeed_bpp_m3h_ed = Qout_erd_hp_m3h_ed                      # Feed to BPP (ED)

        # Assign values based on the following technology
        if following_tech == "oaro":
            Qfeed_hpp_m3h, Qfeed_bpp_m3h, Pout_erd_lp = Qfeed_hpp_m3h_oaro, Qfeed_bpp_m3h_oaro, Pout_erd_lp_oaro
        elif following_tech == "ed":
            Qfeed_hpp_m3h, Qfeed_bpp_m3h, Pout_erd_lp = Qfeed_hpp_m3h_ed, Qfeed_bpp_m3h_ed, Pout_erd_lp_ed

        
        if tech_config_and_params['pumps_erd_included_in_capital_cost']:
            erd_cost = 0  # [USD_current] #economic_function.estimation_cost_erd_px(Qin_erd_hp_m3h, proj_config_and_params)
            # HPP and BPP cost estimations
            pump_cost_hpp = 0  #estimate_pump_cost(Qfeed_hpp_m3h, Pfeed - Pfeed_hpp, tech_config_and_params, proj_config_and_params) 
            pump_cost_bpp = 0  #estimate_pump_cost(Qfeed_bpp_m3h, tech_config_and_params['booster_pump']['pressure_delta'], tech_config_and_params, proj_config_and_params)
        else:
            erd_cost = economic_function.estimation_cost_erd_px(Qin_erd_hp_m3h, proj_config_and_params)  # [USD_current]
            # HPP and BPP cost estimations
            pump_cost_hpp = estimate_pump_cost(Qfeed_hpp_m3h, Pfeed - Pfeed_hpp, tech_config_and_params, proj_config_and_params)  # [USD_current]
            pump_cost_bpp = estimate_pump_cost(Qfeed_bpp_m3h, tech_config_and_params['booster_pump']['pressure_delta'], tech_config_and_params, proj_config_and_params)  # [USD_current]

    else:
        print("Neglecting ERD and its effects")
        
        # Default values when ERD is not considered
        erd_cost = 0
        Qfeed_hpp_m3h = feed_vol_flow_per_train_m3h
        Qfeed_bpp_m3h = 0
        
        # Placeholder for HPP and BPP cost estimations
        pump_cost_hpp = 0
        pump_cost_bpp = 0

    # power
    HPP_efficiency_oaro = calculate_pump_efficiency(Qfeed_hpp_m3h_oaro*24)
    BPP_efficiency_oaro = calculate_pump_efficiency(Qfeed_bpp_m3h_oaro*24)
    HPP_efficiency_ed = calculate_pump_efficiency(Qfeed_hpp_m3h_ed*24)
    BPP_efficiency_ed = calculate_pump_efficiency(Qfeed_bpp_m3h_ed*24)

    ### power
    ## oaro
    power_total_oaro = spec_elec_consumption * Qperm_m3h  # [kW_el] Total plant power
    power_HPP_oaro = (Pfeed - Pfeed_hpp) * Qfeed_hpp_m3h_oaro / HPP_efficiency_oaro * 1e5 * 1e-3 / 3600  # kW
    power_BPP_oaro = tech_config_and_params['booster_pump']['pressure_delta'] * Qfeed_bpp_m3h_oaro / BPP_efficiency_oaro * 1e5 * 1e-3 / 3600  # kW
    power_BOP_oaro = power_total_oaro - (power_HPP_oaro + power_BPP_oaro)
    # ED
    power_HPP_ed = (Pfeed - Pfeed_hpp) * Qfeed_hpp_m3h_ed / HPP_efficiency_ed * 1e5 * 1e-3 / 3600  # kW
    power_BPP_ed = tech_config_and_params['booster_pump']['pressure_delta'] * Qfeed_bpp_m3h_ed / BPP_efficiency_ed * 1e5 * 1e-3 / 3600  # kW
    #power_BOP_ed = power_total - (power_HPP_ed + power_BPP_ed)

    if following_tech == "ed":
        power_HPP = power_HPP_ed
        power_BPP = power_BPP_ed
        power_saved = (power_HPP_oaro + power_BPP_oaro) - (power_HPP_ed + power_BPP_ed)
        saved_spec_elec_consumption = power_saved / Qperm_m3h  # [kWh/m3 of perm]
        power_BOP = power_BOP_oaro - power_saved
        power_total = power_BOP + power_HPP_ed + power_BPP_ed
    elif following_tech == "oaro":
        power_HPP = power_HPP_oaro
        power_BPP = power_BPP_oaro
        power_saved = 0
        saved_spec_elec_consumption = power_saved / Qperm_m3h  # [kWh/m3 of perm]
        power_BOP = power_BOP_oaro - power_saved
        power_total = power_total_oaro
    
    tot_spec_elec_consumption = spec_elec_consumption - saved_spec_elec_consumption  # [kWh/m3 of perm]
    # elec consumption
    annual_elec_consumption = tot_spec_elec_consumption * Qperm_m3_per_annum  # [kWh_el/a]
    

    # capital expenditures (USD)
    total_capital_cost = spec_capital_cost * Qperm_m3day_capacity  # [USD_current]
    
    ## annualization of capital cost (USD_current/y)
    depr_period = tech_config_and_params["depr_period"]
    interest_rate = proj_config_and_params["interest_rate"]
    annualized_capital_cost = calculate_annual_depreciation_cost(interest_rate, depr_period, total_capital_cost)
    annualized_HPP_cost = calculate_annual_depreciation_cost(interest_rate, depr_period, pump_cost_hpp)
    annualized_BPP_cost = calculate_annual_depreciation_cost(interest_rate, depr_period, pump_cost_bpp)
    annualized_erd_cost = calculate_annual_depreciation_cost(interest_rate, depr_period, erd_cost)
    
    # annual fixed operating cost (USD_current/y)
    annual_fixed_opex = spec_fixed_opex * Qperm_m3day_capacity  # [USD_current/y]

    # total annual cost
    total_annual_fixed_cost = annualized_capital_cost + annual_fixed_opex

    levelized_fixed_cost_per_m3_dist = total_annual_fixed_cost / Qperm_m3_per_annum
    levelized_fixed_cost_per_m3_brine = total_annual_fixed_cost / Qretent_m3_per_annum

    
    #### variable operating costs (assumed to consist only of energy)
    # electricity
    annual_electric_cost = economic_function.estimation_electric_cost_from_m3h(tot_spec_elec_consumption, Qperm_m3h, electricity_cost, tech_config_and_params)
    annual_operating_cost = annual_electric_cost

    levelized_operating_cost_per_m3_dist = annual_electric_cost / Qperm_m3_per_annum
    levelized_operating_cost_per_m3_brine = annual_electric_cost / Qretent_m3_per_annum
    
    ## total (fixed + variable operating)
    annual_total_cost = total_annual_fixed_cost + annual_operating_cost
    levelized_cost_per_m3_dist = levelized_fixed_cost_per_m3_dist + levelized_operating_cost_per_m3_dist
    levelized_cost_per_m3_brine = levelized_fixed_cost_per_m3_brine + levelized_operating_cost_per_m3_brine
    
    annual_revenue_purewater = price_purewat_usd_m3 * Qperm_m3_per_annum
    annual_Mdist = Qperm_m3_per_annum

    hpro_inputs = ResultList(title="HPRO inputs", xls_sheet="hpro", results=[
        #('input and parameters', ('', '')),
        ('Number of trains', (N_trains, '-')),
        ('Feed vol. flow rate (per train)', (feed_vol_flow_per_train_m3h, 'm3/h')),
        ('Feed pressure to HPRO', (Pfeed, 'bar')),
        ('Feed pressure to HPP (retentate of SWRO)', (Pfeed_hpp, 'bar')),
        ('Feed conc. (all ions)', (feed_ion_conc_ppm_tot, 'ppm')),
        ('Retent expected conc. (all ions)', (retent_ion_conc_ppm_tot, 'ppm')),
        ('Perm expected conc. (all ions)', (perm_ion_conc_ppm_tot, 'ppm')),
        ('Recovery rate', (recovery_rate, '-')),
        ('Spec. capital cost', (spec_capital_cost, 'USD_current/(m3_capacity/day)')),
        ('Spec. fixed opex', (spec_fixed_opex, 'USD_current/year/(m3_capacity/day)')),
        ('Elec cost', (electricity_cost, 'USD/kWh')),
        ('Plant availability', (tech_config_and_params['plant_availability'], '-')),
        ('Following tech after HPRO', (following_tech, '-')),
        ('Feed pressure for following tech after HPRO', (Pout_erd_lp, 'bar')),
        ])

    hpro_tech_results = ResultList(title="Technical results", xls_sheet="hpro", xls_y0=5, results=[
        ('Flow rates per train', ('m3/h', 'm3/a', 'kg/h')),
        ('Permeate', (Qperm_m3h, Qperm_m3_per_annum, Mperm_kgh)),
        ('Retentate', (Qretent_m3h, Qretent_m3_per_annum, Mretent_kgh)),
        ('power and electricity consumption and feed flow rate and pressure delta', ('kW', 'kWh/m3_perm', 'kWh_el/a', 'm3/h', 'bar')),
        ('HPP', (power_HPP, power_HPP / Qperm_m3h, Qfeed_hpp_m3h, Pfeed - Pfeed_hpp)),
        ('BPP', (power_BPP, power_BPP / Qperm_m3h, Qfeed_bpp_m3h, tech_config_and_params['booster_pump']['pressure_delta'])),
        ('saved power in case following_tech is electrodialysis', (power_saved, saved_spec_elec_consumption)),
        ('Power of balance of plant', (power_BOP, power_BOP / Qperm_m3h)),
        ('Total', (power_total, tot_spec_elec_consumption, annual_elec_consumption))
        ])
    
    hpro_eco_results = ResultList(title="Economic results per train", xls_sheet="hpro", xls_y0=11, results=[
        ('capex', ('$/y', '$', '$/m3_perm_capacity/day')),
        ('HP pump', (annualized_HPP_cost, pump_cost_hpp, pump_cost_hpp/Qperm_m3day_capacity)),
        ('BP pump', (annualized_BPP_cost, pump_cost_bpp, pump_cost_bpp/Qperm_m3day_capacity)),
        ('ERD', (annualized_erd_cost, erd_cost, erd_cost/Qperm_m3day_capacity)),
        ('Total capital', (annualized_capital_cost, total_capital_cost, total_capital_cost/Qperm_m3day_capacity)),
        ('opex', ('$/y', '$/m3_perm', '$/a/m3_perm_capacity/day')),
        ('fixed', (annual_fixed_opex, annual_fixed_opex/Qperm_m3_per_annum, annual_fixed_opex/Qperm_m3day_capacity)),
        ('variable', ('$/y', '$/m3_perm')),
        ('electric energy', (annual_electric_cost, annual_electric_cost/Qperm_m3_per_annum)),
        ])

    hpro_tot_cost_results = ResultList(title="total costs per train", xls_sheet="hpro", xls_y0=16, results=[
        ('total annual fixed cost', (total_annual_fixed_cost, '$/y')),
        ('levelized fixed cost (per m3 dist)', (levelized_fixed_cost_per_m3_dist, '$/m3_dist')),
        ('levelized fixed cost (per m3 brine)', (levelized_fixed_cost_per_m3_brine, '$/m3_brine')),
        ('annual variable operating cost', (annual_operating_cost, '$/y')),
        ('levelized operating cost (per m3 dist)', (levelized_operating_cost_per_m3_dist, '$/m3_dist')),
        ('levelized operating cost (per m3 brine)', (levelized_operating_cost_per_m3_brine, '$/m3_brine')),
        ('total annual cost', (annual_total_cost, '$/y')),
        ('levelized cost (per m3 dist)', (levelized_cost_per_m3_dist, '$/m3_dist')),
        ('levelized cost (per m3 brine)', (levelized_cost_per_m3_brine, '$/m3_brine')),
        ('tot annual revenue water', (annual_revenue_purewater, '$/y')),
        ('Mdist annual', (annual_Mdist, 'm3/y'))
        ])

    return [hpro_inputs, hpro_tech_results, hpro_eco_results, hpro_tot_cost_results]

def get_erd_flowrates(tech_config_and_params, Pfeed, Qretent_m3h, Pin_erd_hp):

    brinetech_base_path = os.path.abspath(os.path.join(os.path.realpath(__file__), "../../../.."))
    # OARO params
    oaro_tech_config_and_params_path = os.path.join(brinetech_base_path, "inputs", "oaro", 'parameters.yml')
    # Load the OARO tech parameters from the YAML file
    with open(oaro_tech_config_and_params_path, "r") as file_params:
        oaro_tech_config_and_params = yaml.load(file_params, Loader=Loader)
    # ED params
    ed_tech_config_and_params_path = os.path.join(brinetech_base_path, "inputs", "electrodialysis", 'parameters.yml')
    # Load the Electrodialysis tech parameters from the YAML file
    with open(ed_tech_config_and_params_path, "r") as file_params:
        ed_tech_config_and_params = yaml.load(file_params, Loader=Loader)



    Pout_erd_lp_oaro = oaro_tech_config_and_params['feed_pressure']  # Expected feed pressure, ~70 bar(g)
    
    Pout_erd_lp_ed = ed_tech_config_and_params['feed_pressure']  # Expected feed pressure, ~0 bar(g)
        
    # Feed flow rates and extractable energy
    Qin_erd_hp_m3h = Qretent_m3h
    extractable_energy_in_erd_oaro = (Pin_erd_hp - Pout_erd_lp_oaro) * Qin_erd_hp_m3h  # High-energy stream from HPRO
    extractable_energy_in_erd_ed = (Pin_erd_hp - Pout_erd_lp_ed) * Qin_erd_hp_m3h  # High-energy stream from HPRO
        
        # Expected output pressure from ERD
    Pout_erd_hp = Pfeed - tech_config_and_params['booster_pump']['pressure_delta']  # Expected pressure
        
    # Portion of HPRO feed diverted to ERD (skipping HPP)
    Qin_erd_lp_m3h_oaro = tech_config_and_params['erd_type']['PX']['efficiency'] * extractable_energy_in_erd_oaro / Pout_erd_hp
    Qin_erd_lp_m3h_ed = tech_config_and_params['erd_type']['PX']['efficiency'] * extractable_energy_in_erd_ed / Pout_erd_hp
    
    return Pout_erd_lp_oaro, Pout_erd_lp_ed, Qin_erd_lp_m3h_oaro, Qin_erd_lp_m3h_ed